nx_server_plugin_sdk 1.0 Server Plugin SDK

Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
nx::sdk::analytics::IMetadata Class Referenceabstract

`#include <i_metadata.h>`

Inheritance diagram for nx::sdk::analytics::IMetadata:

## Public Member Functions
virtual const char * | typeId () const =0
virtual float | confidence () const =0
Ptr< const IAttribute > | attribute (int index) const
virtual int | attributeCount () const =0
Public Member Functions inherited from nx::sdk::Interface< IMetadata >
virtual IRefCountable * | queryInterface (const InterfaceId *id)
Ptr< Interface > | queryInterface ()
Ptr< const Interface > | queryInterface () const
Public Member Functions inherited from nx::sdk::IRefCountable
virtual | ~IRefCountable ()=default
template<class Interface >
Ptr< Interface > | queryInterface ()
template<class Interface >
Ptr< const Interface > | queryInterface () const
virtual int | addRef () const =0
virtual int | releaseRef () const =0
int | refCountThreadUnsafe () const

## Static Public Member Functions
static auto | interfaceId ()
Static Public Member Functions inherited from nx::sdk::IRefCountable
static auto | interfaceId ()

## Protected Member Functions
virtual const IAttribute * | getAttribute (int index) const =0
Protected Member Functions inherited from nx::sdk::Interface< IMetadata >
virtual IRefCountable * | queryInterface (const IRefCountable::InterfaceId *id) override
IRefCountable * | queryInterfaceSupportingDeprecatedId (const IRefCountable::InterfaceId *id, const Uuid &deprecatedInterfaceId)

## Additional Inherited Members
Static Protected Member Functions inherited from nx::sdk::IRefCountable
template<int len>
static const InterfaceId * | makeId (const char(&charArray)[len])
template<int len, int alternativeLen>
static std::vector< const InterfaceId * > | makeIdWithAlternative (const char(&charArray)[len], const char(&alternativeCharArray)[alternativeLen])
template<class TemplateInstance , class TemplateArg , int len>
static const InterfaceId * | makeIdForTemplate (const char(&baseIdCharArray)[len])
static std::vector< const InterfaceId * > | alternativeInterfaceIds (const InterfaceId *id)
static std::vector< const InterfaceId * > | alternativeInterfaceIds (std::vector< const InterfaceId *> ids)

## Detailed Description

A particular item of metadata (e.g. event, detected object) which is contained in a metadata packet.

## Member Function Documentation

## ◆ attribute()

Ptr<const IAttribute> nx::sdk::analytics::IMetadata::attribute | ( | int | index | ) | const
| inline

Provides values of so-called Metadata Attributes - typically, some object or event properties (e.g. age or color), represented as a name-value map.

See the specification for Attribute names in Attributes with pre-defined behavior.

Parameters

  index | 0-based index of the attribute.

Returns
  Item of an attribute array, or null if index is out of range.

## ◆ attributeCount()

virtual int nx::sdk::analytics::IMetadata::attributeCount | ( |  | ) | const
| pure virtual

Returns
  Number of items in the attribute array.

## ◆ confidence()

virtual float nx::sdk::analytics::IMetadata::confidence | ( |  | ) | const
| pure virtual

Level of confidence in range (0..1]

## ◆ getAttribute()

virtual const IAttribute* nx::sdk::analytics::IMetadata::getAttribute | ( | int | index | ) | const
| protectedpure virtual

Called by attribute()

## ◆ typeId()

virtual const char* nx::sdk::analytics::IMetadata::typeId | ( |  | ) | const
| pure virtual

Human-readable hierarchical type, e.g. "someCompany.someEngine.lineCrossing".

The documentation for this class was generated from the following file:

- src/nx/sdk/analytics/i_metadata.h